"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _react = _interopRequireDefault(require("react"));

var _styledComponents = _interopRequireDefault(require("styled-components"));

var _reactPose = _interopRequireDefault(require("react-pose"));

var _propTypes = _interopRequireDefault(require("prop-types"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _templateObject3() {
  var data = _taggedTemplateLiteral(["\n\tfont-family: ", ";\n\ttext-transform: uppercase;\n\tz-index: 5;\n\ttransition: color 0.5s;\n\tcolor: white;\n"]);

  _templateObject3 = function _templateObject3() {
    return data;
  };

  return data;
}

function _templateObject2() {
  var data = _taggedTemplateLiteral(["\n\tdisplay: inline-flex;\n\tposition: relative;\n\talign-items: center;\n\tjustify-content: center;\n\tbackground: ", ";\n\tborder-radius: 3px;\n\tborder: none;\n\tpadding: 8px;\n\twidth: auto;\n\topacity: 1;\n\twidth: ", ";\n\tz-index: 999999999;\n\tcursor: pointer;\n\ttransition: background 0.5s;\n"]);

  _templateObject2 = function _templateObject2() {
    return data;
  };

  return data;
}

function _templateObject() {
  var data = _taggedTemplateLiteral(["\n\tposition: fixed;\n\ttransform: translateX(200%) translateZ(0px);\n\twidth: 100%;\n\toverflow: hidden;\n\tbackground-color: ", ";\n\tbackground-size: cover;\n\tbackground-position: center;\n\theight: ", ";\n\tpadding-top: 100px;\n\tpadding-left: 40px;\n\tdisplay: flex;\n\tflex-direction: column;\n\tjustify-content: flex-start;\n\tlist-style: none;\n\tmargin: 0;\n\ttop: 0;\n\tbottom: 0;\n\tright: 0;\n\tz-index: 2;\n\tbox-shadow: 28px 2px 60px 40px black;\n\n\t@media (min-width: 768px) {\n\t\twidth: 40%;\n\t}\n"]);

  _templateObject = function _templateObject() {
    return data;
  };

  return data;
}

function _taggedTemplateLiteral(strings, raw) { if (!raw) { raw = strings.slice(0); } return Object.freeze(Object.defineProperties(strings, { raw: { value: Object.freeze(raw) } })); }

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var Menu =
/*#__PURE__*/
function (_React$Component) {
  _inherits(Menu, _React$Component);

  function Menu(props) {
    var _this;

    _classCallCheck(this, Menu);

    _this = _possibleConstructorReturn(this, _getPrototypeOf(Menu).call(this, props));

    _defineProperty(_assertThisInitialized(_this), "handleMenuClick", function () {
      _this.setState({
        isOpen: !_this.state.isOpen
      });
    });

    _defineProperty(_assertThisInitialized(_this), "renderChildren", function () {
      return _react["default"].Children.map(_this.props.children, function (child) {
        return _react["default"].cloneElement(child, {
          onClick: _this.handleMenuClick
        });
      });
    });

    _defineProperty(_assertThisInitialized(_this), "renderMenuIconText", function () {
      if (!_this.props.iconTextWhenOpen || !_this.props.iconTextWhenClosed) {
        return;
      }

      return _this.state.isOpen ? _this.props.iconTextWhenOpen : _this.props.iconTextWhenClosed;
    });

    _defineProperty(_assertThisInitialized(_this), "renderMenuOpenIcon", function () {
      if (_this.state.isOpen) {
        return typeof _this.props.openIcon === "function" ? _this.props.openIcon() : _this.props.openIcon;
      } else if (!_this.state.isOpen) {
        return typeof _this.props.closeIcon === "function" ? _this.props.closeIcon() : _this.props.closeIcon;
      }
    });

    _this.state = {
      isOpen: false
    };
    return _this;
  }

  _createClass(Menu, [{
    key: "render",
    value: function render() {
      return _react["default"].createElement(_react["default"].Fragment, null, _react["default"].createElement(StyledMenuAction, _extends({
        "data-testid": "actionBtn",
        role: "button",
        "aria-label": !this.state.isOpen ? "Open menu" : "Close menu",
        openColor: this.props.buttonColorOpen,
        closedColor: this.props.buttonColorClosed,
        width: this.props.width,
        open: this.state.isOpen,
        onClick: this.handleMenuClick
      }, this.props), _react["default"].createElement(MenuText, {
        font: this.props.font
      }, this.renderMenuIconText()), this.renderMenuOpenIcon()), _react["default"].createElement(Sidebar, {
        "data-testid": "hidden-menu",
        backgroundColor: this.props.menuBackgroundColor // style={{ ...this.props.sideBarStyles }}
        ,
        className: "sidebar-menu",
        pose: this.state.isOpen ? "open" : "closed",
        "aria-hidden": this.state.isOpen ? "false" : "true"
      }, this.renderChildren()));
    }
  }]);

  return Menu;
}(_react["default"].Component); // STYLES


exports["default"] = Menu;

var StyledSideBar = _styledComponents["default"].ul(_templateObject(), function (props) {
  return props.backgroundColor ? props.backgroundColor : "red";
}, function (props) {
  return props.height ? props.height : "100vh";
});

var Sidebar = (0, _reactPose["default"])(StyledSideBar)({
  open: {
    x: "0%",
    delayChildren: 100,
    staggerChildren: 80,
    transition: {
      type: "tween",
      duration: 300
    }
  },
  closed: {
    x: "200%",
    delay: 200,
    transition: {
      type: "tween",
      duration: 500
    }
  }
});

var StyledMenuAction = _styledComponents["default"].button(_templateObject2(), function (props) {
  return props.open ? props.openColor : props.closedColor;
}, function (props) {
  return props.width;
});

var MenuText = _styledComponents["default"].span(_templateObject3(), function (props) {
  return props.font;
});

Menu.propTypes = {
  buttonColorOpen: _propTypes["default"].string,
  buttonColorClosed: _propTypes["default"].string,
  iconTextWhenOpen: _propTypes["default"].string,
  iconTextWhenClosed: _propTypes["default"].string,
  iconTextFont: _propTypes["default"].string,
  openIcon: _propTypes["default"].oneOfType([_propTypes["default"].string, _propTypes["default"].func, _propTypes["default"].element]),
  closeIcon: _propTypes["default"].oneOfType([_propTypes["default"].string, _propTypes["default"].func, _propTypes["default"].element]),
  menuBackgroundColor: _propTypes["default"].string
};
Menu.defaultProps = {
  buttonColorOpen: "yellow",
  buttonColorClosed: "#006bba",
  iconTextWhenOpen: "Close",
  iconTextWhenClosed: "Open",
  iconTextFont: "Comic Sans MS",
  openIcon: null,
  closeIcon: null,
  menuBackgroundColor: "red"
};